#!/bin/bash
# PukiWiki for Apache-2.2+PHP5
#	BuildScript for Plamo Linux 4.6
#			by Jun Kuwamura <juk@linet.gr.jp> on 2009-06-07
# require:
#	httpd-2.2.x
#	php-5.2.x
#
VERSION=0.7.3
SRC_URI="http://laconi.ca/laconica-${VERSION}.tar.gz"

SRC_FILE=${SRC_URI##*/}
SRC_NAME=${SRC_FILE%%.tar.gz}
PAC_NAME=laconica-${VERSION}

REL=P1
CPU=noname
SYS_NAME="${CPU}-${REL}"

PLAMO=/expo/Build
SRC_DIR=$PLAMO/Archive/www/php/appli
PAC_DIR=$PLAMO/Packages/4.6/09_webdb/03_PHP.tgz
BUILD_DIR=$PLAMO/laconica
CUSTOM_DIR=${BUILD_DIR}/Custom
PAT_FILE=

echo $PAC_DIR
if [ ! -d $PAC_DIR ]; then
  mkdir -p  $PAC_DIR
fi
echo $SRC_DIR/$SRC_FILE
if [ ! -f $SRC_DIR/$SRC_FILE ]; then
  if [ ! -d $SRC_DIR ]; then
    mkdir -p $SRC_DIR
  fi
  ( cd $SRC_DIR; wget $SRC_URI )
fi


umask 022
CWD=`pwd`
WORK=$CWD/work
rm -rf $WORK/*
mkdir -p $WORK
export LANG=C
export LC_ALL=C
export CFLAGS="-O2 -march=$CPU"
export PATH=$PATH:/usr/X11R7/bin:/opt/teTeX/bin:/opt/php5/bin


tar xvfz $SRC_DIR/$SRC_FILE
if [ -f "$PAT_FILE" ]; then
  patch < $PAT_FILE
fi
if [ "$SRC_NAME" != "$PAC_NAME" ]; then
  mv $SRC_NAME $PAC_NAME
fi
cd $PAC_NAME

if [ "$PAT_FILE" != "" ]; then
  patch -P1 < $CUSTOM_DIR/$PAT_FILE
fi

DOC_DIR=/usr/share/doc/$PAC_NAME
mkdir -p $WORK/$DOC_DIR
cp -p COPYING EVENTS.txt README   $WORK/$DOC_DIR
cp -p $BUILD_DIR/`basename $0`  \
    $WORK/$DOC_DIR
chown -R root.root $WORK/$DOC_DIR
chmod -R a+rX,go-w $WORK/$DOC_DIR

cd ..

DESTDIR=$WORK/opt/htdocs/
mkdir -p $DESTDIR
mv $PAC_NAME $DESTDIR

cd $WORK
mkdir -p install
sed -e "s/_VERSION_/$VERSION/g" \
    -e "s/_PACKAGENAME_/${PAC_NAME}-${SYS_NAME}/" \
    $CUSTOM_DIR/doinst.sh > install/doinst.sh

cp -p $CUSTOM_DIR/config.pgsql.php opt/htdocs/$PAC_NAME/
cp -p $CUSTOM_DIR/create_laconica_db.sh opt/htdocs/$PAC_NAME/db/

mkdir -p $WORK/opt/htdocs/AppList || exit 1
TYP=2 #(0:httpd, 1:libraries, 2:application)
cat >> $WORK/opt/htdocs/AppList/${TYP}.${PAC_NAME}.list <<__EOCL__
TYP	$TYP
NAM	${PAC_NAME}
URL	http://laconi.ca/
DOC	${DOC_DIR}/
EXE	/laconica/
REM	 wiki written in PHP with eventlist/evententry plugin
__EOCL__


echo "n
" | makepkg ${PAC_NAME}.tgz

echo -n "$PAC_DIR/${PAC_NAME}-${SYS_NAME}.tgz"
if `mv -v ${PAC_NAME}.tgz  $PAC_DIR/${PAC_NAME}-${SYS_NAME}.tgz 1>/dev/null 2>&1`; then
  echo " ... done"
else
  echo " ... false"
fi

cd $CWD
